package
{
	import controller.ApplicationStartCommand;
	import controller.TestCommand;
	
	import interfaces.IMyModule1;
	import interfaces.IMyModule2;
	
	import org.robotlegs.mvcs.ModuleSignalContext;
	
	import signals.ApplicationStartedSignal;
	import signals.TestSignal;

	public class RLModuleTestContext extends ModuleSignalContext
	{
		override public function startup():void {
			viewMap.mapType(IMyModule1);
			viewMap.mapType(IMyModule2);
			
			mediatorMap.mapView(RLModuleTest, RLModuleTestMediator);
			
			moduleSignalCommandMap.mapSignalClass(TestSignal, TestCommand);
			moduleSignalCommandMap.mapSignalClass(ApplicationStartedSignal, ApplicationStartCommand, true);	// dispatched in Module1Mediator
		}
	}
}