package org.robotlegs.mvcs
{
	import flash.display.DisplayObjectContainer;
	import flash.system.ApplicationDomain;
	
	import org.robotlegs.base.ModuleSignalCommandMap;
	import org.robotlegs.base.SignalCommandMap;
	import org.robotlegs.core.IInjector;
	import org.robotlegs.core.IModuleSignalCommandMap;
	import org.robotlegs.core.IModuleSignalContext;
	import org.robotlegs.core.ISignalCommandMap;
	import org.robotlegs.utilities.modular.mvcs.ModuleContext;
	
	public class ModuleSignalContext extends ModuleContext implements IModuleSignalContext
	{
		
		protected var _moduleSignalCommandMap:IModuleSignalCommandMap;
		protected var _signalCommandMap:ISignalCommandMap;
		
		
		public function ModuleSignalContext(contextView:DisplayObjectContainer = null, autoStartup:Boolean = true, parentInjector:IInjector = null, applicationDomain:ApplicationDomain = null)
		{
			super(contextView, autoStartup, parentInjector, applicationDomain);
		}
		
		
		override public function dispose():void
		{
			super.dispose();
			signalCommandMap = null;
			moduleSignalCommandMap = null;
		}
		
		
		public function get moduleSignalCommandMap():IModuleSignalCommandMap
		{
			return _moduleSignalCommandMap;
		}
		
		
		public function set moduleSignalCommandMap(value:IModuleSignalCommandMap):void
		{
			_moduleSignalCommandMap = value;
		}
		
		
		public function get signalCommandMap():ISignalCommandMap
		{
			return _signalCommandMap || (_signalCommandMap = new SignalCommandMap(injector.createChild(injector.applicationDomain)));
		}
		
		
		public function set signalCommandMap(value:ISignalCommandMap):void
		{
			_signalCommandMap = value; 
		}
		
		
		protected function initializeModuleSignalCommandMap():void
		{
			if (injector.hasMapping(IModuleSignalCommandMap))
			{
				moduleSignalCommandMap = injector.getInstance(IModuleSignalCommandMap);
			}
			else
			{
				moduleSignalCommandMap = new ModuleSignalCommandMap(injector);
				injector.mapValue(IModuleSignalCommandMap, moduleSignalCommandMap);
			}
		}
		
		
		override protected function mapInjections():void
		{
			super.mapInjections();
			initializeModuleSignalCommandMap();
			injector.mapValue(ISignalCommandMap, signalCommandMap);
		}
	}
}